// Generated by delombok at Tue Nov 14 22:36:35 UTC 2023
/*
 * Matomo Java Tracker
 *
 * @link https://github.com/matomo/matomo-java-tracker
 * @license https://github.com/matomo/matomo-java-tracker/blob/master/LICENSE BSD-3 Clause
 */
package org.matomo.java.tracking.parameters;

import lombok.NonNull;

/**
 * A key-value pair that represents custom information. See
 * <a href="https://matomo.org/faq/how-to/guide-to-using-custom-variables-deprecated/">How do I use Custom Variables?</a>
 *
 * <p>If you are not already using Custom Variables to measure your custom data, Matomo recommends to use the
 * <a href="https://matomo.org/docs/custom-dimensions/">Custom Dimensions feature</a> instead.
 * There are many <a href="https://matomo.org/faq/general/faq_21117/">advantages of Custom Dimensions over Custom
 * variables</a>. Custom variables will be deprecated in the future.
 *
 * @deprecated Should not be used according to the Matomo FAQ: <a href="https://matomo.org/faq/how-to/guide-to-using-custom-variables-deprecated/">How do I use Custom Variables?</a>
 */
@Deprecated
public class CustomVariable {
  private int index;
  @NonNull
  private String key;
  @NonNull
  private String value;

  /**
   * Instantiates a new custom variable.
   *
   * @param key   the key of the custom variable (required)
   * @param value the value of the custom variable (required)
   */
  public CustomVariable(@NonNull String key, @NonNull String value) {
    if (key == null) {
      throw new java.lang.NullPointerException("key is marked non-null but is null");
    }
    if (value == null) {
      throw new java.lang.NullPointerException("value is marked non-null but is null");
    }
    this.key = key;
    this.value = value;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int getIndex() {
    return this.index;
  }

  @NonNull
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getKey() {
    return this.key;
  }

  @NonNull
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getValue() {
    return this.value;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setIndex(final int index) {
    this.index = index;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setKey(@NonNull final String key) {
    if (key == null) {
      throw new java.lang.NullPointerException("key is marked non-null but is null");
    }
    this.key = key;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setValue(@NonNull final String value) {
    if (value == null) {
      throw new java.lang.NullPointerException("value is marked non-null but is null");
    }
    this.value = value;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public CustomVariable(final int index, @NonNull final String key, @NonNull final String value) {
    if (key == null) {
      throw new java.lang.NullPointerException("key is marked non-null but is null");
    }
    if (value == null) {
      throw new java.lang.NullPointerException("value is marked non-null but is null");
    }
    this.index = index;
    this.key = key;
    this.value = value;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "CustomVariable(index=" + this.getIndex() + ", key=" + this.getKey() + ", value=" + this.getValue() + ")";
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof CustomVariable)) return false;
    final CustomVariable other = (CustomVariable) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$key = this.getKey();
    final java.lang.Object other$key = other.getKey();
    if (this$key == null ? other$key != null : !this$key.equals(other$key)) return false;
    final java.lang.Object this$value = this.getValue();
    final java.lang.Object other$value = other.getValue();
    if (this$value == null ? other$value != null : !this$value.equals(other$value)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof CustomVariable;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $key = this.getKey();
    result = result * PRIME + ($key == null ? 43 : $key.hashCode());
    final java.lang.Object $value = this.getValue();
    result = result * PRIME + ($value == null ? 43 : $value.hashCode());
    return result;
  }
}
