// Generated by delombok at Tue Nov 14 22:37:27 UTC 2023
package org.matomo.java.tracking.servlet;

import edu.umd.cs.findbugs.annotations.NonNull;
import java.io.IOException;
import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.HttpFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.matomo.java.tracking.MatomoRequest;
import org.matomo.java.tracking.MatomoTracker;

/**
 * This filter can be used to automatically send a request to the Matomo server for every request
 * that is received by the servlet container.
 */
public class MatomoTrackerFilter extends HttpFilter {
  @java.lang.SuppressWarnings("all")
  private static final org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(MatomoTrackerFilter.class);
  private final MatomoTracker tracker;

  @Override
  protected void doFilter(@NonNull HttpServletRequest req, @NonNull HttpServletResponse res, @NonNull FilterChain chain) throws IOException, ServletException {
    MatomoRequest matomoRequest = ServletMatomoRequest.fromServletRequest(JavaxHttpServletWrapper.fromHttpServletRequest(req)).build();
    log.debug("Sending request {}", matomoRequest);
    tracker.sendRequestAsync(matomoRequest);
    super.doFilter(req, res, chain);
  }

  @java.lang.SuppressWarnings("all")
  public MatomoTrackerFilter(final MatomoTracker tracker) {
    this.tracker = tracker;
  }
}
